%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

Name: mMass
Summary: Open Source Mass Spectrometry Tool
Version: 5.5.0
Release: 10%{?dist}
License: GPLv3+
Group:   Applications/Engineering
URL: http://www.mmass.org/
Source0: http://www.mmass.org/download/files/v%{version}/mmass_v%{version}_source.zip

## Database links
Source1: http://www.mmass.org/download/files/compounds/compounds_lipidmaps.zip
Source2: http://www.mmass.org/download/files/compounds/compounds_norine.zip
Source3: http://www.mmass.org/download/files/compounds/compounds_fungal_peptides.zip

## Example links
Source4: http://www.mmass.org/download/files/examples/examples_general.zip
Source5: http://www.mmass.org/download/files/examples/examples_hdx.zip
Source6: http://www.mmass.org/download/files/examples/examples_cpeptides.zip

Source7: %{name}.desktop

## https://bugzilla.redhat.com/show_bug.cgi?id=1159957
Patch0: %{name}-remove-icc-profile.patch

BuildRequires: python2-devel, desktop-file-utils 
BuildRequires: python-libs
BuildRequires: wxPython-devel, numpy
BuildRequires: dos2unix

Requires: wxPython, numpy

%description
Open Source Mass Spectrometry Tool

%package examples
Summary: %{name} examples
Group: Applications/Engineering
Requires: %{name} = %{version}-%{release}
BuildArch: noarch
%description examples
%{name} examples data.

%package doc
Summary: %{name} documentation
Group: Applications/Engineering
BuildArch: noarch
%description doc
%{name} PDF User Guide.

%prep
%setup -q -n %{name}
mv readme.txt README.txt
rm mspy/calculations.so setup.py

sed -i 's/\r$//' license.txt

## Fix wrong-script-end-of-line-encoding error
dos2unix mspy/plot_canvas.py 

## Add Python shebang 
sed -i -e '1i#!/usr/bin/python' gui/*.py
sed -i -e '1i#!/usr/bin/python' mspy/*.py

## Unpacking zipped databases 
unzip %{SOURCE1}
mv LIPIDMAPS/readme.txt LIPIDMAPS/lipidmaps-readme.txt
rm -rf  __MACOSX

unzip %{SOURCE2} 
mv readme.txt norine-readme.txt

unzip %{SOURCE3}
mv readme.txt fungal_peptides-readme.txt

## Unpacking zipped examples and
## removing all useless/proprietary files
unzip %{SOURCE4}
rm -rf __MACOSX

unzip %{SOURCE5}
rm -rf __MACOSX

unzip %{SOURCE6}
rm -rf __MACOSX

%patch0 -p1

%build
## Need just build 'calculations' extension
pushd mspy
CFLAGS="$RPM_OPT_FLAGS" %{__python2} setup.py build
mv -f build/lib.*/calculations.so ./calculations.so
popd

%install
pushd mspy
%{__python2} setup.py install --skip-build --root $RPM_BUILD_ROOT
popd 

## Making installation directories
mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}/configs
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/database
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}/examples
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}/mspy
mkdir -p $RPM_BUILD_ROOT%{_libdir}/%{name}/gui/images/gtk
mkdir -p $RPM_BUILD_ROOT%{_bindir}

## Removing useless files
rm mspy/setup.py
rm mspy/*.pyd

## Allocating all files
install -p -m 755 mspy/*.py* $RPM_BUILD_ROOT%{_libdir}/%{name}/mspy
install -p -m 755 mspy/*.so $RPM_BUILD_ROOT%{_libdir}/%{name}/mspy
install -p -m 644 configs/*.xml $RPM_BUILD_ROOT%{_libdir}/%{name}/configs
install -p -m 755 gui/*.py* $RPM_BUILD_ROOT%{_libdir}/%{name}/gui
install -p -m 644 gui/images/gtk/icon_about.png $RPM_BUILD_ROOT%{_libdir}/%{name}/gui/images/gtk
install -p -m 644 gui/images/gtk/icon_about.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/mmass.png
install -p -m 755 mmass.py* $RPM_BUILD_ROOT%{_libdir}/%{name}
install -p -m 644 *.xml $RPM_BUILD_ROOT%{_datadir}/%{name}/database
install -p -m 644 General*Examples/*.msd HDX*Examples/*.msd Cyclic*Peptide*Examples/*.msd $RPM_BUILD_ROOT%{_datadir}/%{name}/examples

desktop-file-install                           \
 --dir=$RPM_BUILD_ROOT%{_datadir}/applications \
%{SOURCE7}

## Make a symbolic link to mmass.py
ln -s %{_libdir}/%{name}/mmass.py $RPM_BUILD_ROOT%{_bindir}/mmass

## Add Python shebang
sed -i -e '1i#!/usr/bin/python' $RPM_BUILD_ROOT%{_libdir}/%{name}/mmass.py

%files
%doc license.txt README.txt *-readme.txt
%{_bindir}/mmass
%{_libdir}/%{name}/
%{python2_sitearch}/*.egg-info
%{_datadir}/%{name}/database/
%{_datadir}/applications/*.desktop
%{_datadir}/pixmaps/mmass.png 

%files examples
%{_datadir}/%{name}/examples/

%files doc
%doc *Guide.pdf license.txt 

%changelog
* Tue Nov 04 2014 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-10
- Copied .png icon in %%{_datadir}/pixmaps

* Tue Nov 04 2014 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-9
- Set Icon key in .desktop file (bz#1159560)
- Made a symbolic link to mmass.py (bz#1160166)
- Remove icc profile from embedded images (bz#1159957)

* Sat Nov 01 2014 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-8
- Fixed Requires packages
- SPEC file cleanups
- Adapted to the Python guide lines for EPEL6

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 5.5.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Nov 19 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-5
- Update LIPID MAPS Database (November 16, 2013)
- User Guide packaged in the .doc subpackage
- Installed new .desktop file

* Tue Sep 17 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-4
- Fixed shebang and wrong-script-end-of-line-encoding  errors
- Added BR dos2unix
- Subpackage database built in main package

* Fri Sep 13 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-3
- examples and database directories are now owned by package
- Set compiler flags
- Main software files now are placed in %%{_libdir}/%%{name}

* Fri Sep 13 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-2
- Python shebang addendum moved to %%prep section
- Use macros in the 'mmass' file creation

* Tue Aug 27 2013 Antonio Trande <sagitter@fedoraproject.org> 5.5.0-1
- Initial build
- 'calculations.so' library destination changed to 'mspy' subdirectory
- Created a 'mmass' binary file 
- Added commands to remove all useless/proprietary/hidden files
